--------------------------------------------------------------------------------
-- Carnage Contest AI (Artificial Intelligence) Script
-- gamma-AI
-- Script by DC, February 2010, www.UnrealSoftware.de
-- edited by farnsworth, March 2010
--------------------------------------------------------------------------------

ai={}
-- the list of non-dead enemies
players={}

-- Initialization Function (called once at each start of AI turn)
function ai_init()
	math.randomseed(os.time())
	ai.movetimer=1
	ai.power=200
	players=playertable(3,0)
	print("Number of enemies:")
	print(table.maxn(players))
	print("Target is player number")
	ai.target=math.random(1,table.maxn(players))
	print(ai.target)
	print("His relative coordinates:")
	ai.targetx=getplayerx(players[ai.target])
	print(ai.targetx-getplayerx(0))
	ai.targety=getplayery(players[ai.target])
	print(ai.targety-getplayery(0))
	ai.aim=math.ceil(math.deg(math.atan2(ai.targetx-getplayerx(0),-ai.targety+getplayery(0))))
	if ai.aim<0 then
		ai.dir=0
	else
		ai.dir=1
	end
	print("Set aim to:")
	print(ai.aim)
end

-- Movement Function (called each frame, pre attack)
function ai_move()
	if ai.movetimer>0 then
		if ai.dir==0 then
			ai_left()
		else
			ai_right()
		end
		ai.movetimer=ai.movetimer-1
	elseif ai.aim~=getplayerrotation(0) then
		if (ai.aim-getplayerrotation(0))*(2*ai.dir-1)>0 then
			ai_down()
		else
			ai_up()
		end
	elseif ai.power>0 then
		ai_attack()
		ai.power=ai.power-1
	end
end

-- Backing Function (called each frame, post attack)
function ai_back()
	if ai.dir==0 then
		ai_right()
	else
		ai_left()
	end
end

--------------------------------------------------------------------------------
-- AI Helper Functions
-- Attention: These functions are also used by orig. AI weapon Lua scripts
-- !!! CHECK ALL DEPENDENCIES WHEN CHANGING !!!
--------------------------------------------------------------------------------